<template>
	<div>
		<SpinnerHolder class="loader" v-if="loading" :background="false"></SpinnerHolder>
		<BlankLayout>
			<template slot="head">
				<CommonHeader :setOrden="true" :showBackButton="true" :title="$t('addressBook')"></CommonHeader>
			</template>
			<template slot="body">
				<div id="mapa">
					<Map
						:location="location"
						:libraries="['places']"
						@getLocation="loadInfo"
						@getLocationData="loadInfoData"
					/>
				</div>
				<div class="content">
					<div class="form-crear">
						<div class="form-group">
							<label>{{ $t('address') }}</label>
							<input
								type="text"
								placeholder="Av industrial #46"
								v-model="address.formatAddress"
							/>
							<span v-if="formErrors.address" class="error">{{ $t('inputEmptyError') }}</span>
						</div>
						<div class="form-group">
							<label>{{ $t('references') }}</label>
							<input
								type="text"
								placeholder="Entre calles."
								v-model="address.references"
							/>
							<span v-if="formErrors.references" class="error">{{ $t('inputEmptyError') }}</span>
						</div>
						<div class="form-group">
							<label>{{ $t('name') }}</label>
							<input
								type="text"
								:placeholder="$t('johnDoe')"
								v-model="name"
							/>
							<span v-if="formErrors.name" class="error">{{ $t('nameError') }}</span>
						</div>
						<div class="form-group">
							<label>{{ $t('correo') }}</label>
							<input
								type="text"
								:placeholder="$t('correoPlaceholder')"
								v-model="email"
							/>
							<span v-if="formErrors.email" class="error">{{ $t('correoError') }}</span>
						</div>
						<div class="form-group">
							<label>{{ $t('telephone') }}</label>
							<input
								type="text"
								:placeholder="$t('telephonePlaceholder')"
								v-model="phone"
							/>
							<span v-if="formErrors.phone" class="error">{{ $t('telephoneRepeatError') }}</span>
						</div>
						<div class="container-check">
							<BeeCheckbox v-model="address.defaultAddress" class="check-box"></BeeCheckbox>
							<span class="text-checks">{{ $t('mainAddress') }}</span>
						</div>
					</div>
				</div>
				<div class="send-container">
					<button class="eliminar-button" @click="formDelete()">{{ $t('delete') }}</button>
					<button class="send-button" @click="confirm()">{{ $t('Confirmar') }}</button>
				</div>

				<Modal v-if="modal" :ShowClose="false">
					<div class="card-modal">
						<p>
							<b>{{ $t('deleteLocation') }}</b>
						</p>

						<div class="card-actions">
							<button @click="cancel()">{{ $t('no') }}</button>
							<button @click="deleteAddress()">{{ $t('yes') }}</button>
						</div>
					</div>
				</Modal>
			</template>
		</BlankLayout>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import BlankLayout from '@/layouts/BlankLayout.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import BeeCheckbox from '@/components/BeeCheckbox.vue'
import Modal from '@/components/Modal.vue'
import Map from '@/components/Map.vue'
import firebase from 'firebase'
import AddressService from '@/services/AddressService'
import AddressBook, { TypeAddressBook, Location as Loc } from '@/models/AddressBook'
import { parseAddress } from '@/utils/MapsUtils'
import Order from '@/models/Order'
import { updateUser } from '@/services/UserService'
import SpinnerHolder from '@/components/SpinnerHolder.vue'

@Component({
	components: {
		BlankLayout,
		CommonHeader,
		AjaxButton,
		BeeCheckbox,
		Modal,
		Map,
		SpinnerHolder
	}
})
export default class Location extends Vue {
	@Prop({ default: '' }) readonly idAddress!: string
	@Prop({ default: '' }) readonly lat!: string
	@Prop({ default: '' }) readonly lng!: string
	@Prop({ default: '' }) readonly length!: string

	loading = false
	modal = false
	firstRegister = false
	location = new firebase.firestore.GeoPoint(Number(this.lat), Number(this.lng))
	order: Order | null = this.$store.state.order
	user = this.$store.state.user
	reference = ''
	name = ''
	email = ''
	phone = ''
	loc: Loc = {
		lat: 0,
		lng: 0
	}
	address: AddressBook = {
		defaultAddress: false,
		location: this.loc,
		formatAddress: '',
		country: '',
		locality: '',
		state: '',
		street: '',
		postal: '',
		references: '',
		type: TypeAddressBook.HOME,
		otherDescription: ''
	}

	formErrors = {
		name: false,
		email: false,
		phone: false,
		address: false,
		references: false
	}

	cancel() {
		this.modal = false
	}

	async deleteAddress() {
		if (this.idAddress != '') {
			await AddressService.deleteAddress(this.idAddress)
		}
		this.$router.push('/locations')
	}

	loadInfo(value) {
		this.loc = new Loc(value.lat, value.lng)
		this.address.location = this.loc
	}

	async loadInfoData(value) {
		const data = value[0]
		this.address.formatAddress = data.formatted_address
		this.address.country = await parseAddress(data, 'country')
		this.address.locality = await parseAddress(data, 'locality')
		this.address.state = await parseAddress(data, 'state')
		this.address.street = await parseAddress(data, 'street')
		this.address.postal = await parseAddress(data, 'postal')
	}

	async confirm() {
		this.loading = true
		if (!this.validForm()) return
		await this.updateData()
		if (this.idAddress != '') {
			await AddressService.updateAddressBook(this.idAddress, this.address)
		} else {
			if(this.firstRegister) this.address.defaultAddress = true
			await AddressService.saveAddressBook(this.address)
		}
		this.loading = false
		this.$router.push('/summary')
	}

	formDelete() {
		this.modal = true
	}

	async updateData() {
		if (!this.validForm()) return
		const update = await updateUser(this.user, this.name, this.email, this.phone, this.user.authToken)
		if (update) {
			await this.$store.dispatch('login', update)
		}
	}

	validForm() {
		this.formErrors = { name: false, email: false, phone: false, address: false, references: false }
		if (!this.name) this.formErrors.name = true
		if (!this.email) this.formErrors.email = true
		if (!this.address.formatAddress) this.formErrors.address = true
		if (!this.address.references) this.formErrors.references = true
		if (this.checkDigitRepeated(this.phone, 5) && this.phone.length !== 10) this.formErrors.phone = true
		for (const error of Object.values(this.formErrors)) {
			if (error == true) {
				this.loading = false
				return false
			}
		}
		return true
	}

	checkDigitRepeated(input: string, repeat: number) {
		const regex = new RegExp('(\\d)\\1{' + repeat + '}', 'g')
		return !!input.match(regex)
	}

	async created() {
		if (this.user) {
			this.name = this.user.name
			this.email = this.user.email
			this.phone = this.user.phone
		}
		if (this.idAddress != '') {
			const request = await AddressService.getAddressBookById(this.idAddress)
			if (request) {
				this.address = request.data
				this.location = this.newLocation
			}
		}
		if(this.length == '0'){
			this.firstRegister = true
		}
	}

	get newLocation() {
		return this.location
	}
}
</script>

<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}
.card-modal {
	background: #ffffff;
	border-radius: 4px;
}
p {
	margin: 0px;
}

#mapa {
	background: #ffffff;
}

.content {
	padding: 1em;
	overflow: hidden;
	.title {
		font-weight: 600;
		font-size: 16px;
		line-height: 24px;
	}
	.text {
		font-weight: normal;
		font-size: 14px;
		color: #828282;
		line-height: 21px;
	}
}

.form-crear {
	label {
		font-weight: normal;
		font-size: 140x;
		line-height: 21px;
		color: #828282;
		margin-bottom: 0.4em;
	}
	.form-group {
		display: grid;

		input {
			border-radius: 7px;
			border: 0.5px solid rgba(192, 192, 192, 1);
			padding: 0.8em 0.8em 0.8em 10px;
		}
		input::-webkit-input-placeholder {
			color: rgba(117, 112, 112, 1);
			font-size: 1em;
		}
		.error {
			font-size: 12px;
			color: red;
		}
	}
	.container-check {
		display: flex;
		margin: 1em 0;
		.text-checks {
			margin-left: 10px;
		}
	}
}

.send-container {
	width: 100%;
	background: white;
	box-shadow: 0px -1px 41px rgba(0, 0, 0, 0.15);
	padding: 0.8em;
	overflow: hidden;
	button {
		height: 46px;
		border-radius: 6px;
		font-weight: 500;
		font-size: 18px;
	}
	.eliminar-button {
		background: #ec6186;
		border: 1px solid #ec6186;
		color: white;
		float:left;
		width: 35%;
		margin-left: 1em;
	}
	.send-button {
		background: #feca38;
		border: 1px solid #feca38;
		float: right;
		width: 50%;
		margin-right: 1em;
	}
}

.card-modal {
	p {
		color: #232323;
		font-weight: 500;
		font-size: 16px;
		line-height: 24px;
		text-align: center;
	}
	.card-actions {
		padding: 1em 3.5em;
		button:first-child {
			background: #e0e0e0;
			color: #828282;
		}
		button {
			font-weight: 500;
			font-size: 18px;
			line-height: 27px;
			text-align: center;
			border-radius: 6px;
			height: 46px;
			border: none;
			width: 38%;
			margin: 0 0.5em;
			background: #2ed775;
			color: #ffffff;
		}
	}
}
</style>
